let main () =
  let lexbuf = Lexing.from_channel stdin in
  try
    let prog = Parser.prog Lexer.token lexbuf in
    Prog.run prog
  with Parsing.Parse_error ->
    let i = lexbuf.Lexing.lex_start_p.Lexing.pos_cnum in
    failwith (Format.sprintf "Syntax error at char %i" i)

let () = 
  try main ()
  with exn -> Printf.eprintf "Error:\n%s\n" (Printexc.to_string exn); exit 2
