open Tags

(* Common syntax for expressions, types, values *)

type t =
  | Name of string
  | Seq of t * t
  | Alt of t * t
  | Star of t
  | Plus of t
  | Eps
  | Elem of SymbolSet.t * t
  | Sub of t | Next of t
  | Test of t * t * t

val def: string -> t
val register: string -> t -> unit

val print: Format.formatter -> t -> unit

val compare: t -> t -> int
val hash: t -> int
val equal: t -> t -> bool

val to_string : t -> string
